"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useClusterer = useClusterer;

var _react = require("react");

var _Supercluster = _interopRequireDefault(require("./Supercluster"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function useClusterer(data, mapDimensions, region, options) {
  const supercluster = (0, _react.useMemo)(() => new _Supercluster.default(options).load(data), [data, options === null || options === void 0 ? void 0 : options.extent, options === null || options === void 0 ? void 0 : options.maxZoom, options === null || options === void 0 ? void 0 : options.minZoom, options === null || options === void 0 ? void 0 : options.minPoints, options === null || options === void 0 ? void 0 : options.radius]);
  const points = (0, _react.useMemo)(() => supercluster.getClustersFromRegion(region, mapDimensions).map(c => {
    var _c$properties;

    const cid = c === null || c === void 0 ? void 0 : (_c$properties = c.properties) === null || _c$properties === void 0 ? void 0 : _c$properties.cluster_id;
    if (!cid) return c;
    return { ...c,
      properties: { ...c.properties,
        getClusterExpansionRegion: () => supercluster.expandCluster(cid)
      }
    };
  }), [supercluster, region.latitude, region.longitude, region.latitudeDelta, region.longitudeDelta, mapDimensions.width, mapDimensions.height]); // @ts-ignore FIXME: Type

  return [points, supercluster];
}
//# sourceMappingURL=useClusterer.js.map